blob: 491242183ab35b0136968ba9583de786db432b0d [file] [log] [blame]
Igor Murashkineaddcd42012-11-26 12:01:11 -08001#!/bin/bash
2
3#
4# Copyright (C) 2012 The Android Open Source Project
5#
6# Licensed under the Apache License, Version 2.0 (the "License");
7# you may not use this file except in compliance with the License.
8# You may obtain a copy of the License at
9#
10# http://www.apache.org/licenses/LICENSE-2.0
11#
12# Unless required by applicable law or agreed to in writing, software
13# distributed under the License is distributed on an "AS IS" BASIS,
14# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15# See the License for the specific language governing permissions and
16# limitations under the License.
17#
18
19#
20# Generate all files we have templates for:
21# docs.html
22# ../src/camera_metadata_tag_info.c
23# ../src/camera_metadata_tags.h
Colin Crossabc7c492017-05-05 09:36:03 -070024# ../../../../frameworks/av/camera/ndk/include/camera/NdkCameraMetadataTags.h
Yin-Chia Yehea7662f2015-12-22 16:25:00 -080025# ../../../../frameworks/av/camera/ndk/impl/ACameraMetadata.cpp
Yin-Chia Yeh6c58d0a2015-12-05 17:20:33 -080026# ../../../../cts/tests/camera/src/android/hardware/camera2/cts/CaptureResultTest.java
Igor Murashkin21d0f1a2013-09-10 12:25:56 -070027# ../../../../frameworks/base/core/java/android/hardware/camera2/CameraCharacteristics.java
28# ../../../../frameworks/base/core/java/android/hardware/camera2/CaptureRequest.java
29# ../../../../frameworks/base/core/java/android/hardware/camera2/CaptureResult.java
Igor Murashkineaddcd42012-11-26 12:01:11 -080030
Igor Murashkinaa133d32013-06-28 17:27:49 -070031if [[ -z $ANDROID_BUILD_TOP ]]; then
32 echo "Please source build/envsetup.sh before running script" >& 2
33 exit 1
34fi
35
Eino-Ville Talvala08885562013-03-18 09:43:57 -070036thisdir=$(cd "$(dirname "$0")"; pwd)
Eino-Ville Talvala47aa24d2013-07-25 17:10:11 -070037fwkdir="$ANDROID_BUILD_TOP/frameworks/base/core/java/android/hardware/camera2/"
Igor Murashkin1dd4ecb2013-12-11 13:31:00 -080038fwkdir_html="$ANDROID_BUILD_TOP/frameworks/base/docs/html"
Yin-Chia Yeh6c58d0a2015-12-05 17:20:33 -080039ctsdir="$ANDROID_BUILD_TOP/cts/tests/camera/src/android/hardware/camera2/cts"
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -070040outdir="$ANDROID_PRODUCT_OUT/obj/ETC/system-media-camera-docs_intermediates"
Colin Crossabc7c492017-05-05 09:36:03 -070041ndk_header_dir="$ANDROID_BUILD_TOP/frameworks/av/camera/ndk/include/camera"
Yin-Chia Yehea7662f2015-12-22 16:25:00 -080042ndk_impl_dir="$ANDROID_BUILD_TOP/frameworks/av/camera/ndk/impl"
Yin-Chia Yehcf145ce2016-04-01 17:37:47 -070043device_info_dir="$ANDROID_BUILD_TOP/cts/tools/cts-device-info/"`
44 `"src/com/android/cts/deviceinfo"
Igor Murashkin1232dd22013-06-21 12:10:42 -070045out_files=()
Igor Murashkineaddcd42012-11-26 12:01:11 -080046
Igor Murashkin5804a482012-12-05 13:06:59 -080047function relpath() {
48 python -c "import os.path; print os.path.relpath('$1', '$PWD')"
49}
50
Igor Murashkin1232dd22013-06-21 12:10:42 -070051# Generates a file. Appends to $out_files array as a side effect.
Igor Murashkineaddcd42012-11-26 12:01:11 -080052function gen_file() {
53 local in=$thisdir/$1
54 local out=$thisdir/$2
55
Igor Murashkinaa133d32013-06-28 17:27:49 -070056 gen_file_abs "$in" "$out"
57 return $?
58}
59
60function gen_file_abs() {
61 local in="$1"
62 local out="$2"
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -070063 local intermediates="$3"
Yin-Chia Yehc9c2c682016-05-25 01:29:55 -070064 local ndk="$4"
65 local spec_file=$thisdir/metadata_properties.xml
Igor Murashkinaa133d32013-06-28 17:27:49 -070066
Yin-Chia Yehc9c2c682016-05-25 01:29:55 -070067 if [[ "$ndk" == "yes" ]]; then
68 spec_file=$thisdir/ndk_metadata_properties.xml
69 fi
70
71 python $thisdir/metadata_parser_xml.py $spec_file $in $out
Igor Murashkin5804a482012-12-05 13:06:59 -080072
73 local succ=$?
74
75 if [[ $succ -eq 0 ]]
76 then
77 echo "OK: Generated $(relpath "$out")"
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -070078 if [[ "$intermediates" != "no" ]]; then
79 out_files+=$'\n'" $out"
80 fi
Igor Murashkin5804a482012-12-05 13:06:59 -080081 else
82 echo "FAIL: Errors while generating $(relpath "$out")" >& 2
83 fi
84
85 return $succ
Igor Murashkineaddcd42012-11-26 12:01:11 -080086}
87
Igor Murashkin1232dd22013-06-21 12:10:42 -070088# Print a list of git repository paths which were affected after file generation
89function affected_git_directories() {
90 local input_files=($@)
91 local git_directories=()
92
93 for file in "${input_files[@]}"; do
94 local dir_path="$(dirname "$file")"
95 echo "Trying to cd into $dir_path" >& /dev/null
96 # Absolute path to the git repository root of that file
97 local git_path="$(cd "$dir_path";
98 git rev-parse --show-toplevel 2> /dev/null)"
99 if [[ $? -eq 0 ]]; then
100 # Both staged and unstaged changes
Igor Murashkinb8dc8812013-07-17 16:29:34 -0700101 local diff_result="$(cd "$dir_path";
102 git status --porcelain | egrep -c -v '^[?][?]')"
Igor Murashkin1232dd22013-06-21 12:10:42 -0700103 echo "Diff result was $diff_result" >& /dev/null
104 echo "Diff result was $diff_result" >& /dev/null
105 if [[ $diff_result -eq 0 ]]; then
Igor Murashkinaa133d32013-06-28 17:27:49 -0700106 echo "No changes in ${git_path}" >& /dev/null
Igor Murashkin1232dd22013-06-21 12:10:42 -0700107 else
108 echo "There are changes in ${git_path}" >& /dev/null
109 git_directories+=("$git_path")
110 fi
111 fi
112 done
113
114 # print as result the unique list of git directories affected
Igor Murashkinaa133d32013-06-28 17:27:49 -0700115 printf %s\\n "${git_directories[@]}" | sort | uniq
Igor Murashkin1232dd22013-06-21 12:10:42 -0700116}
117
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700118# Insert a file into the middle of another, starting at the line containing the
119# start delim and ending on the end delim, both of which are replaced
120function insert_file() {
121 local src_part="$1"
122 local dst_file="$2"
123 local start_delim="/*@O~"
124 local end_delim="~O@*/"
125
126 local start_line="$(grep -n -F "${start_delim}" "${dst_file}" | cut -d: -f1)"
127 local end_line="$(grep -n -F "${end_delim}" "${dst_file}" | cut -d: -f1)"
128
129 # Adjust cutoff points to use start/end line from inserted file
130 (( start_line-- ))
131 (( end_line++ ))
132
133 # Do some basic sanity checks
134
135 if [[ -z "$start_line" ]]; then
136 echo "No starting delimiter found in ${dst_file}" >& 2
137 echo "FAIL: Errors in inserting into $(relpath ${dst_file})" >& 2
138 return 1
139 fi
140
141 if [[ -z "$end_line" ]]; then
142 echo "No ending delimiter found in ${dst_file}" >& 2
143 echo "FAIL: Errors in inserting into $(relpath ${dst_file})" >& 2
144 return 1
145 fi
146
147 if [[ "$start_line" -ge "$end_line" ]]; then
148 echo "Starting delim later than ending delim: $start_line vs $end_line" >& 2
149 echo "FAIL: Errors in inserting into $(relpath ${dst_file})" >& 2
150 return 1
151 fi
152
153 local tmp_name=$(mktemp -t XXXXXXXX)
154
155 # Compose the three parts of the final file together
156
157 head -n "$start_line" "${dst_file}" > "${tmp_name}"
158 cat "${src_part}" >> "${tmp_name}"
159 tail -n "+${end_line}" "${dst_file}" >> "${tmp_name}"
160
161 # And replace the destination file with the new version
162
163 mv "${tmp_name}" "${dst_file}"
164 echo "OK: Inserted $(relpath "$src_part") into $(relpath "$dst_file")"
165 out_files+=$'\n'" $dst_file"
166}
167
Igor Murashkin1dd4ecb2013-12-11 13:31:00 -0800168# Recursively copy a directory tree from $1 to $2. Pretty-prints status.
169function copy_directory() {
170 local src="$thisdir/$1" # Relative to directory of this script
171 local dst="$2" # Absolute path
172
173 if ! [[ -d $src ]]; then
174 echo "FAIL: Source directory $src does not exist" >& 2
175 return 1
176 fi
177 if ! [[ -d $dst ]]; then
178 echo "FAIL: Destination directory $dst does not exist" >& 2
179 return 1
180 fi
181
182 cp -R "$src" "$dst"
183 local retval=$?
184
185 if [[ $retval -ne 0 ]]; then
186 echo "ERROR: Failed to copy $(relpath "$src") to $(relpath "$dst")" >& 2
187 else
188 echo "OK: Copied $(relpath "$src") to $(relpath "$dst")"
189 fi
190
191 return $retval
192}
193
Igor Murashkin0334aa02012-12-04 14:59:53 -0800194$thisdir/metadata-check-dependencies || exit 1
Igor Murashkinc469f7d2013-04-23 14:31:02 -0700195$thisdir/metadata-validate $thisdir/metadata_properties.xml || exit 1
Igor Murashkineaddcd42012-11-26 12:01:11 -0800196$thisdir/metadata-parser-sanity-check || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700197
198# Generate HTML properties documentation
Igor Murashkineaddcd42012-11-26 12:01:11 -0800199gen_file html.mako docs.html || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700200
201# Generate C API headers and implementation
Igor Murashkineaddcd42012-11-26 12:01:11 -0800202gen_file camera_metadata_tag_info.mako ../src/camera_metadata_tag_info.c || exit 1
203gen_file camera_metadata_tags.mako ../include/system/camera_metadata_tags.h || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700204
Yin-Chia Yehea7662f2015-12-22 16:25:00 -0800205#Generate NDK header
Yin-Chia Yehc9c2c682016-05-25 01:29:55 -0700206gen_file_abs ndk_camera_metadata_tags.mako "$ndk_header_dir/NdkCameraMetadataTags.h" yes yes || exit 1
Yin-Chia Yehea7662f2015-12-22 16:25:00 -0800207
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700208# Generate Java API definitions
209mkdir -p "${outdir}"
210gen_file_abs CameraMetadataEnums.mako "$outdir/CameraMetadataEnums.java.part" no || exit 1
Igor Murashkin21d0f1a2013-09-10 12:25:56 -0700211gen_file_abs CameraCharacteristicsKeys.mako "$outdir/CameraCharacteristicsKeys.java.part" no || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700212gen_file_abs CaptureRequestKeys.mako "$outdir/CaptureRequestKeys.java.part" no || exit 1
213gen_file_abs CaptureResultKeys.mako "$outdir/CaptureResultKeys.java.part" no || exit 1
214
215insert_file "$outdir/CameraMetadataEnums.java.part" "$fwkdir/CameraMetadata.java" || exit 1
Igor Murashkin21d0f1a2013-09-10 12:25:56 -0700216insert_file "$outdir/CameraCharacteristicsKeys.java.part" "$fwkdir/CameraCharacteristics.java" || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700217insert_file "$outdir/CaptureRequestKeys.java.part" "$fwkdir/CaptureRequest.java" || exit 1
218insert_file "$outdir/CaptureResultKeys.java.part" "$fwkdir/CaptureResult.java" || exit 1
Yin-Chia Yehc9b27dd2016-02-23 19:18:15 -0800219
220# Generate CTS test code
221gen_file_abs CaptureResultTest.mako "$outdir/CaptureResultTest.java.part" no || exit 1
Yin-Chia Yeh3a52b8f2015-05-05 23:49:07 -0700222insert_file "$outdir/CaptureResultTest.java.part" "$ctsdir/CaptureResultTest.java" || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700223
Yin-Chia Yehea7662f2015-12-22 16:25:00 -0800224# Generate NDK implementation
225gen_file_abs ACameraMetadata.mako "$outdir/ACameraMetadata.cpp.part" no || exit 1
226insert_file "$outdir/ACameraMetadata.cpp.part" "$ndk_impl_dir/ACameraMetadata.cpp" || exit 1
227
Yin-Chia Yehc9b27dd2016-02-23 19:18:15 -0800228# Generate CameraDeviceInfo code
229gen_file_abs CameraDeviceInfo.mako "$outdir/CameraDeviceInfo.java.part" no || exit 1
230insert_file "$outdir/CameraDeviceInfo.java.part" "$device_info_dir/CameraDeviceInfo.java" || exit 1
231
232# Generate protocol buffer definition corresponding to CameraDeviceInfo
233gen_file camera_device_info.mako ./camera_device_info.proto || exit 1
234
Igor Murashkin1dd4ecb2013-12-11 13:31:00 -0800235# Copy ./images directory into javadoc directory
236copy_directory "images" "$fwkdir_html" || exit 1
237
Igor Murashkin1232dd22013-06-21 12:10:42 -0700238echo ""
239echo "===================================================="
Igor Murashkineaddcd42012-11-26 12:01:11 -0800240echo "Successfully generated all metadata source files"
Igor Murashkin1232dd22013-06-21 12:10:42 -0700241echo "===================================================="
242echo ""
243
244echo "****************************************************"
245echo "The following git repositories need to be committed:"
246echo "****************************************************"
247echo ""
248affected_git_directories "${out_files[@]}"
249echo ""
Igor Murashkineaddcd42012-11-26 12:01:11 -0800250
251exit 0